
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dir.h>
#include "classes.h"
#include "out.h"

unsigned int oldcur,shortcur=0x0607,tallcur=0x0507,nocur=0x2000;


tpovs inttopov(int i)
{
tpovs p;

switch(i)
 {
  case 1:p=kouzelnik;break;
  case 2:p=lucistnik;break;
  case 3:p=valecnik; break;

 }
return p;
}

trass inttoras(int i)
{
trass r;

switch(i)
 {
  case 1:r=clovek;break;
  case 2:r=elf;    break;
  case 3:r=thran;  break;

 }
return r;
}


tgame::tgame(int i)

{

if (i==0)
 {
  mainmrec=definemenus(r_mainm);
  clrscr();
  setcursor(nocur);

  init();

 }
}

void tgame::drawlogo(int x,int y)
{

writeat(x,y,YELLOW,BLUE,"MAR 2000");
writeat(x+9,y,YELLOW,BLACK,"- Ve Slubch Kothoru v0.1-July 2000");
}

void tgame::init(void)
{
fillscr(1,1,80,25,DARKGRAY,BLACK,176);
drawlogo(1,25);


tnewgame ng(0);
tmenur main(mainmrec);

switch(main.selected)
 {
 case 4:quit();break;
 case 1:ng.init();init();break;
 default:init(); break;


 }

}

void tgame::quit(void)
{
textcolor(WHITE);
textbackground(BLACK);
clrscr();
drawlogo(1,1);
writeat(1,2,WHITE,BLACK,"BYE!");

setcursor(shortcur);
gotoxy(1,24);
}



tmenurec definemenus(menurecords m)
{

tmenurec r;

FILE *f;
char line[81];
char section[5];
int x;

f=fopen("menudef.dat","r");


 switch(m)
  {
   case r_mainm:strcpy(section,"@main");
		break;
   case r_nmain:strcpy(section,"@ngm");
		break;
   case r_nras:strcpy(section,"@ngr");
		break;
   case r_npov:strcpy(section,"@ngp");
		break;


  }

  while (feof(f)==0)
	{
	  fscanf(f,"%s",line);
	  if (strcmp(line,section)==0) break ;
	}


fscanf(f,"%s",line);
r.topics=atoi(line);
fscanf(f,"%s",line);
r.left=atoi(line);
fscanf(f,"%s",line);
r.right=atoi(line);
fscanf(f,"%s",line);
r.top=atoi(line);
fscanf(f,"%s",line);
r.bottom=atoi(line);

fscanf(f,"%s",line);
r.borderstyle=atoi(line);

fscanf(f,"%s",line);
r.bfcol=atoi(line);
fscanf(f,"%s",line);
r.cbfcol=atoi(line);
fscanf(f,"%s",line);
r.bbcol=atoi(line);
fscanf(f,"%s",line);
r.cbbcol=atoi(line);
fscanf(f,"%s",line);
r.menucol=atoi(line);
fscanf(f,"%s",line);
r.bordercol=atoi(line);

int i,e;

fgets(line,81,f);
fgets(line,81,f);
strcpy(r.name,line);

for (x=1;x<r.topics+1;x++)
{
 fgets(line,81,f);
 strcpy(r.topicnames[x],line);
}


fclose(f);

return r;



}






tmenu::tmenu(tmenurec r)
{
rec=r;
selected=1;
init();


}

void tmenu::init(void)
{

 drawmenu();
// run();

}

void tmenur::run(void)
{
int ch;
boolean exit=false;

do
 {
 ch=getkey();
 switch(ch)
 {
   case kenter:exit=true;break;
   case kup:if (selected!=1) selected-=1; else selected=rec.topics;drawbuttons(selected);break;
   case kdown:if (selected!=rec.topics) selected+=1; else selected=1;drawbuttons(selected);break;
   case kesc:selected=-1;exit=true;break;

 } ;

 }while (!exit);

}

tmenur::tmenur(tmenurec r):tmenu(r)
{


run();
};




void tmenu::drawmenu(void)
{
int x,y;

drawwindowf(rec.left,rec.top,rec.right,rec.bottom,rec.bordercol,rec.menucol,rec.borderstyle,177);

int len=strlen(rec.name);
writeat(rec.left+(rec.right-rec.left-len)/2,rec.top+2,rec.bordercol,rec.menucol,rec.name);


drawbuttons(selected);





}

void tmenu::drawbuttons(int selected)
{
int space=rec.bottom-rec.top-2-4;
int up=rec.top+1+2;
int left;
float mid=(space/rec.topics);
int x,y;
int tcol,bcol;
int len=0;



for (x=1;x<rec.topics+1;x++)
 if (strlen(rec.topicnames[x])>len) len=strlen(rec.topicnames[x]);


len+=4;
if ((len%2)!=0) len++;




left=(int)(rec.left+(rec.right-rec.left-len)/2);

for (x=1;x<rec.topics+1;x++)
 {
 if (x!=selected) {tcol=rec.bfcol;bcol=rec.bbcol;}
 else  {tcol=rec.cbfcol;bcol=rec.cbbcol;};



 fillscr(left,up+((int)(mid))*x,left+len,up+((int)(mid))*x,bcol,BLACK,219);
 writeat((int)(left+((len-strlen(rec.topicnames[x])+1)/2)),up+((int)(mid))*x,tcol,bcol,rec.topicnames[x]);


  }


}


tnewgame::tnewgame(int i)
{


if (i==0)
 {


  mainrec=definemenus(r_nmain);
  rasrec=definemenus(r_nras);
  povrec=definemenus(r_npov);

  strcpy(name,"Neznm hrdina");

  povo.typ=valecnik;
  rasa.typ=clovek;

  strcpy(povo.name[kouzelnik],skou);
  strcpy(povo.name[lucistnik],sluc);
  strcpy(povo.name[valecnik],sval);

  strcpy(rasa.name[clovek],sclo);
  strcpy(rasa.name[elf],self);
  strcpy(rasa.name[thran],sthr);



 }

}

void tnewgame::init(void)
{
 textbackground(BLACK);
 clrscr();

 int ch;
 boolean exit=false;


  drawinfo();

 tmenur main(mainrec);

 switch(main.selected)
 {
  case 4:break;
  case 1:break;
  case 2:tmenu ras(rasrec);
	  drawinfo();
	  do
	   {
	    drawraspov(0);
	    ch=getkey();
	    switch(ch)
	    {
	     case kup:if (ras.selected!=1) ras.selected-=1;else ras.selected=ras.rec.topics;ras.drawbuttons(ras.selected);rasa.typ=inttoras(ras.selected);break;
	     case kdown:if (ras.selected!=ras.rec.topics) ras.selected+=1;else ras.selected=1;ras.drawbuttons(ras.selected);rasa.typ=inttoras(ras.selected);break;
	     case kenter:exit=true;break;
	    };
	   }while(!exit);
	 init();
	 break;
  case 3:tmenu pov(povrec);
	  drawinfo();
	  do
	   {
	    drawraspov(1);
	    ch=getkey();
	    switch(ch)
	    {
	     case kup:if (pov.selected!=1) pov.selected-=1;else pov.selected=pov.rec.topics;pov.drawbuttons(pov.selected);povo.typ=inttopov(pov.selected);break;
	     case kdown:if (pov.selected!=pov.rec.topics) pov.selected+=1;else pov.selected=1;pov.drawbuttons(pov.selected);povo.typ=inttopov(pov.selected);break;
	     case kenter:exit=true;break;
	    };

	   }while(!exit);
	 init();
	 break;

 }

}

pyr tnewgame::drawinfo(pyr)
{
 fillscr(27,1,53,5,WHITE,0,32);
 writeatf(28,2,15,0,"Jmno:    %s",name);
 writeatf(28,3,15,0,"Rasa:     %s",rasa.name[rasa.typ]);
 writeatf(28,4,15,0,"Povoln: %s",povo.name[povo.typ]);

}

/*pyr tnewgame::loadinfo(pyr)
{
 FILE *f;
 char line[81];
 f=fopen("nginfo.dat","r");

 fgets(line,81,f);
 fgets(line,81,f);

 int i;

 for (i=1;i<11;i++)
  fgets(info[4][i],81,f);
 fgets(line,81,f);

 for (i=1;i<11;i++)
  fgets(info[5][i],81,f);
 fgets(line,81,f);

 for (i=1;i<11;i++)
  fgets(info[6][i],81,f);
 fgets(line,81,f);

 for (i=1;i<11;i++)
  fgets(info[1][i],81,f);
 fgets(line,81,f);

 for (i=1;i<11;i++)
  fgets(info[2][i],81,f);
 fgets(line,81,f);

 for (i=1;i<11;i++)
  fgets(info[3][i],81,f);
 fgets(line,81,f);

 fclose(f);
} */

pyr tnewgame::drawraspov(int rp)
{
 int i;

 if (rp==0)

      switch(rasa.typ)
      {
       case clovek:i=1;break;
       case elf:i=2;break;
       case thran:i=3;break;

       }
     else if (rp==1)
     switch(povo.typ)
      {
       case kouzelnik:i=4;break;
       case lucistnik:i=5;break;
       case valecnik:i=6;break;
       } ;



for (int t=1;t<11;t++)
writeat(28,8+t,15,0,info[i][t]);

}



thero::thero(int i)
{
if (i==0)
 {
  /*strcpy(name,"Neznm hrdina");

  strcpy(pov.name[kouzelnik],skou);
  strcpy(pov.name[lucistnik],sluc);
  strcpy(pov.name[valecnik],sval);

  strcpy(ras.name[clovek],sclo);
  strcpy(ras.name[elf],self);
  strcpy(ras.name[thran],sthr);
    */
 }
}











