#include <conio.h>
#include <stdlib.h>
#include <bios.h>
#include <stdio.h>
#include <stdarg.h>
#include <dos.h>
#include "out.h"


void writeat(int x,int y,int fcolor,int bcolor,char *text)
{
gotoxy(x,y);
textcolor(fcolor);
textbackground(bcolor);
cprintf(text);
 }

void writeatf(int x, int y, int fcolor,int bcolor,char *format, ...)
{
 va_list arg_ptr;
 char output[81];


 va_start(arg_ptr, format);
 vsprintf(output, format, arg_ptr);
 writeat(x,y,fcolor,bcolor,output);

}

void fillscr(int left,int top,int right,int bottom,int fcolor,int bcolor,int ch)
{
int x,y;

textcolor(fcolor);
textbackground(bcolor);

for (x=left;x<right+1;x++)
{
  for (y=top;y<bottom+1;y++)
 {
 gotoxy(x,y);
 putch(ch);
  }
}
}

void drawwindow(int left,int top,int right,int bottom,int bordercolor,int innercolor,int borderstyle)
{
int x,y;
fillscr(left,top,right,bottom,innercolor,BLACK,219);

for (x=left+1;x<right;x++)
  {
   switch(borderstyle)
    {case 1:writeatf(x,top,bordercolor,innercolor,"%c",205);
	    writeatf(x,bottom,bordercolor,innercolor,"%c",205);
	    break;
     case 0:writeatf(x,top,bordercolor,innercolor,"%c",196);
	    writeatf(x,bottom,bordercolor,innercolor,"%c",196);
	    break;
     case 2:writeatf(x,top,bordercolor,innercolor,"%c",220);
	    writeatf(x,bottom,bordercolor,innercolor,"%c",223);
	    break;
     }
 }


for (y=top+1;y<bottom;y++)
  {
   switch(borderstyle)
    {case 1:writeatf(left,y,bordercolor,innercolor,"%c",186);
	    writeatf(right,y,bordercolor,innercolor,"%c",186);
	    break;
     case 0:writeatf(right,y,bordercolor,innercolor,"%c",179);
	    writeatf(left,y,bordercolor,innercolor,"%c",179);
	    break;
     case 2:writeatf(left,y,bordercolor,innercolor,"%c",221);
	    writeatf(right,y,bordercolor,innercolor,"%c",222);
	    break;
     }
  }


   switch(borderstyle)
    {case 1:writeatf(left,top,bordercolor,innercolor,"%c",201);
	    writeatf(right,top,bordercolor,innercolor,"%c",187);
	    writeatf(left,bottom,bordercolor,innercolor,"%c",200);
	    writeatf(right,bottom,bordercolor,innercolor,"%c",188);
	    break;
     case 0:writeatf(left,top,bordercolor,innercolor,"%c",218);
	    writeatf(right,top,bordercolor,innercolor,"%c",191);
	    writeatf(left,bottom,bordercolor,innercolor,"%c",192);
	    writeatf(right,bottom,bordercolor,innercolor,"%c",217);
	    break;
    case 2:writeatf(left,top,bordercolor,innercolor,"%c",220);
	    writeatf(right,top,bordercolor,innercolor,"%c",220);
	    writeatf(left,bottom,bordercolor,innercolor,"%c",223);
	    writeatf(right,bottom,bordercolor,innercolor,"%c",223);
	    break;
     }

}


void drawwindowf(int left,int top,int right,int bottom,int bordercolor,int innercolor,int borderstyle,int ch)
{
int x,y;

fillscr(left,top,right,bottom,innercolor,BLACK,ch);

for (x=left+1;x<right;x++)
  {
   switch(borderstyle)
    {case 1:writeatf(x,top,bordercolor,innercolor,"%c",205);
	    writeatf(x,bottom,bordercolor,innercolor,"%c",205);
	    break;
     case 0:writeatf(x,top,bordercolor,innercolor,"%c",196);
	    writeatf(x,bottom,bordercolor,innercolor,"%c",196);
	    break;
     case 2:writeatf(x,top,bordercolor,innercolor,"%c",220);
	    writeatf(x,bottom,bordercolor,innercolor,"%c",223);
	    break;
     }
 }


for (y=top+1;y<bottom;y++)
  {
   switch(borderstyle)
    {case 1:writeatf(left,y,bordercolor,innercolor,"%c",186);
	    writeatf(right,y,bordercolor,innercolor,"%c",186);
	    break;
     case 0:writeatf(right,y,bordercolor,innercolor,"%c",179);
	    writeatf(left,y,bordercolor,innercolor,"%c",179);
	    break;
     case 2:writeatf(left,y,bordercolor,innercolor,"%c",221);
	    writeatf(right,y,bordercolor,innercolor,"%c",222);
	    break;
     }
  }


   switch(borderstyle)
    {case 1:writeatf(left,top,bordercolor,innercolor,"%c",201);
	    writeatf(right,top,bordercolor,innercolor,"%c",187);
	    writeatf(left,bottom,bordercolor,innercolor,"%c",200);
	    writeatf(right,bottom,bordercolor,innercolor,"%c",188);
	    break;
     case 0:writeatf(left,top,bordercolor,innercolor,"%c",218);
	    writeatf(right,top,bordercolor,innercolor,"%c",191);
	    writeatf(left,bottom,bordercolor,innercolor,"%c",192);
	    writeatf(right,bottom,bordercolor,innercolor,"%c",217);
	    break;
     case 2:writeatf(left,top,bordercolor,innercolor,"%c",220);
	    writeatf(right,top,bordercolor,innercolor,"%c",220);
	    writeatf(left,bottom,bordercolor,innercolor,"%c",223);
	    writeatf(right,bottom,bordercolor,innercolor,"%c",223);
	    break;
     }
}


int getkey(void)
{
 int key, lo, hi;

 key = bioskey(0);
 lo = key & 0X00FF;
 hi = (key & 0XFF00) >> 8;
 return((lo == 0) ? hi + 256 : lo);
}

void setcursor(unsigned int shape)
{
 union REGS reg;


 reg.h.ah = 1;
 reg.x.cx = shape;
 int86(0X10, &reg, &reg);
}



















