unit Types;
interface


type it=-32767..32767;

     TMenus=(m_main,m_new,m_ras,m_pov,m_atr,               m_end);

     TMenurec=record
	       Left,
	       Top,
	       Right,
	       Bottom,
	       FButCol,
	       BButCol,
	       CFButCol,
	       CBButCol,
	       MenuCol,
	       BorderCol,
	       FrameStyle,
	       Topics:it;
	       Name:string[20];
	       TopicNames:array[1..20]of string[20];

	      end;

    TRecs=array[TMenus]of TMenuRec;

    TRas=(Clovek,Elf,Thran);

    TRasa=record
	   Typ:TRas;
	   Name:string[20];
	  end;

    TPov=(Kouzelnik,Lucistnik,Valecnik);

    TPovolani=record
	   Typ:TPov;
	   Name:string[20];
	  end;

    TRaces=array[TRas]of TRasa;

    TClasses=array[TPov]of TPovolani;

    TAttribs=(Sil,Obr,Odl,Int,Vle,Chr,Poh,Bsil,Bobr,Bodl,Bint,Bvle,Bchr,Bpoh,Mana,Zdravi);

    Tattrib=record
	     CurVal,
	     OrigVal:it;
	     Name:string[20];

	    end;

    TVlastnosti=array[Tattribs]of TAttrib;

    TPos=record
	  X,
	  Y:it;
	 end;



procedure DefineMenus;
function TextInput(X,Y,lenght,FCol,BCol:it;Default:string):string;
procedure CalcAttribs(R:Tras;P:TPov;VL:TVlastnosti;var VVL:TVlastnosti);
procedure UrciUrZt(P:TPov;var Z:TAttrib;var U:TAttrib);


const  Rasy:TRaces=((Typ:Clovek;Name:'lovk'),(Typ:Elf;Name:'Elf'),(Typ:Thran;Name:'Thrn'));
       Povolani:TClasses=((Typ:Kouzelnik;Name:'Kouzelnk'),(Typ:Lucistnik;Name:'Luitnk'),(Typ:Valecnik;Name:'Vlenk'));
       Vlastnosti:TVlastnosti=((CurVal:0;OrigVal:0;Name:'Sla'),
			 (CurVal:0;OrigVal:0;Name:'Obratnost'),
			 (CurVal:0;OrigVal:0;Name:'Odolnost'),
			 (CurVal:0;OrigVal:0;Name:'Inteligence'),
			 (CurVal:0;OrigVal:0;Name:'Vle'),
			 (CurVal:0;OrigVal:0;Name:'Charisma'),
			 (CurVal:0;OrigVal:0;Name:'Pohyblivost'),
			 (CurVal:0;OrigVal:0;Name:'Sla-Bonus'),
			 (CurVal:0;OrigVal:0;Name:'Obratnost-Bonus'),
			 (CurVal:0;OrigVal:0;Name:'Odolnost-Bonus'),
			 (CurVal:0;OrigVal:0;Name:'Inteligence-Bonus'),
			 (CurVal:0;OrigVal:0;Name:'Vle-Bonus'),
			 (CurVal:0;OrigVal:0;Name:'Charisma-Bonus'),
			 (CurVal:0;OrigVal:0;Name:'Pohyblivost-Bonus'),
			 (CurVal:0;OrigVal:0;Name:'Mana'),
			 (CurVal:0;OrigVal:0;Name:'Zdrav'));

      cUtok:TAttrib=(CurVal:0;OrigVal:0;Name:'tok');
      cObrana:TAttrib=(CurVal:0;OrigVal:0;Name:'Obrana');





var
    MenuRecs:TRecs;


const
    shortcur=$0607;tallcur=$0007;nocur=$2000;


    kUP=#72;
    kDOWN=#80;
    kLEFT=#75;
    kRIGHT=#77;
    kENTER=#13;
    kESC=#27;
    F1=#59;
    F2=#60;
    F3=#61;
    F4=#62;
    F5=#63;
    F6=#64;
    F7=#65;
    F8=#66;
    F9=#67;
    F10=#68;
    kPGUP=#73;
    kPGDN=#81;
    kINS=#82;
    kDEL=#83;
    kHOME=#71;
    kEND=#79;

    MaxText=100;


   MapExit=0;
   Zed=1;
   SJehl=2;
   SList=3;
   Palma=4;
   Kaktus=5;
   VPotok=6;
   VJez=7;
   VMore=8;
   Trava=9;
   Savana=10;
   Poust=11;
   PKam=12;
   PDrev=13;
   Gate=14;
   Teleport=15;
   Snih=16;
   Pole=17;
   Cesta=18;

   E1=1;
   E2=2;
   E3=3;
   E4=4;
   E5=5;
   E6=6;
   T1=7;
   T2=8;
   T3=9;
   T4=10;
   T5=11;
   NPC=12;

   IHero=#1;
   INPC=#2;
   ITruhla='?';
   ICreature=#234;
   IWall=#178;
   IPalma=#244;
   ISList=#6;
   ISJehl=#24;
   IKaktus='|';
   IVMore=#219;
   IVPotok=#177;
   IVJez=#219;
   ITeleport=#240;
   IGate=#239;
   ITerrain=#177;
   IPodlaha=#219;
   IExit='X';
   IPole=#176;
   ICesta=#177;


   MaxSpec=200;


implementation

uses out,crt;

procedure UrciUrZt(P:TPov;var Z:TAttrib;var U:TAttrib);
 begin
  U.origval:=4;U.CurVal:=4;U.Name:='rove';
  Z.name:='Zkuenost';
  case P of
  Kouzelnik:begin Z.CurVal:=4100;Z.OrigVal:=5250;end;
  Lucistnik:begin Z.CurVal:=2600;Z.OrigVal:=3450;end;
  Valecnik:begin Z.CurVal:=2700;Z.OrigVal:=3675;end;
  end;
 end;

procedure DefineMenus;
 var i:it;
     f:text;
     section:string[5];
     line:string[80];
     menus:tmenus;
     cod:it;

 begin
  Assign(f,'data\menudef.dat');

  for menus:=m_main to m_end do

   begin
    Reset(f);

     case Menus of
      m_main:section:='@main';
      m_new:section:='@ngm';
      m_ras:section:='@ngr';
      m_pov:section:='@ngp';
      m_atr:section:='@nga';

     end;

   while not eof(f) do
    begin
     readln(f,line);
     if line=section then break;
    end;

   readln(f,line);Val(line,Menurecs[menus].Topics,cod);
   readln(f,line);Val(line,Menurecs[menus].Left,cod);
   readln(f,line);Val(line,Menurecs[menus].Right,cod);
   readln(f,line);Val(line,Menurecs[menus].Top,cod);
   readln(f,line);Val(line,Menurecs[menus].Bottom,cod);
   readln(f,line);Val(line,Menurecs[menus].FrameStyle,cod);
   readln(f,line);Val(line,Menurecs[menus].FButCol,cod);
   readln(f,line);Val(line,Menurecs[menus].CFButCol,cod);
   readln(f,line);Val(line,Menurecs[menus].BButCol,cod);
   readln(f,line);Val(line,Menurecs[menus].CBButCol,cod);
   readln(f,line);Val(line,Menurecs[menus].MenuCol,cod);
   readln(f,line);Val(line,Menurecs[menus].BorderCol,cod);

   readln(f,MenuRecs[menus].Name);

   for i:=1 to MenuRecs[menus].Topics do
     readln(f,MenuRecs[menus].Topicnames[i]);

   end;
  Close(f);
 end;

function TextInput(X,Y,lenght,FCol,BCol:it;Default:string):string;
 var Buf:string[100];
     i,Pos:it;
     ch:char;
 begin


  SetCursor(tallcur);
  Pos:=1;
  for i:=1 to lenght+1 do
  writeat(x+i-1,y,FCol,BCol,#32);
  for i:=1 to lenght+1 do
  Buf[i]:=#32;
  GotoXY(X,Y);
  {Write(Buf);
  {GotoXY(X,Y);
  }
  repeat


   ch:=readkey;
   case ch of
    #33..#255:if pos<=lenght then begin Buf[pos]:=ch;write(ch);Inc(Pos);end;
    #32:if pos<=lenght then begin Buf[pos]:=' ';write(ch);Inc(Pos);end;
    #8:if pos>1 then begin dec(pos);buf[pos]:=' ';gotoxy(x+pos-1,y);write(buf[pos]);gotoxy(x+pos-1,y);end;

   end;

  until ch=#13;

  SetCursor(nocur);

  TextInput:=Buf;


 end;



procedure CalcAttribs(R:Tras;P:TPov;VL:TVlastnosti;var VVL:TVlastnosti);

 procedure UrciSil;
  begin
    case R of
    Clovek:case P of
	   Kouzelnik,Lucistnik:VL[Sil].OrigVal:=4+Random(6)+Random(6)+2;
	   Valecnik:VL[Sil].OrigVal:=12+Random(6);
	   end;
    Elf:case P of
	   Kouzelnik,Lucistnik:VL[Sil].OrigVal:=5+Random(6)+1;
	   Valecnik:VL[Sil].OrigVal:=12+Random(6)+1;
	   end;
    Thran:case P of
	   Kouzelnik,Lucistnik:VL[Sil].OrigVal:=9+Random(6)+1;
	   Valecnik:VL[Sil].OrigVal:=13+Random(6)+1;
	   end;
   end;
  end;

 procedure UrciObr;
  begin
    case R of
    Clovek:case P of
	   Kouzelnik,Valecnik:VL[Obr].OrigVal:=8+Random(6)+1;
	   Lucistnik:VL[Obr].OrigVal:=13+Random(6)+1;
	   end;
    Elf:case P of
	   Kouzelnik,Valecnik:VL[Obr].OrigVal:=9+Random(6)+1;
	   Lucistnik:VL[Obr].OrigVal:=14+Random(6)+1;
	   end;
    Thran:case P of
	   Kouzelnik,Valecnik:VL[Obr].OrigVal:=9+Random(6)+1;
	   Lucistnik:VL[Obr].OrigVal:=14+Random(6)+1;
	   end;
   end;
  end;


  procedure UrciOdl;
  begin
    case R of
    Clovek,Thran:case P of
	   Kouzelnik,Lucistnik:VL[odl].OrigVal:=8+Random(6)+1;
	   Valecnik:VL[odl].OrigVal:=13+Random(6)+1;
	   end;
    Elf:case P of
	   Kouzelnik,Lucistnik:VL[odl].OrigVal:=5+Random(6)+1;
	   Valecnik:VL[odl].OrigVal:=8+Random(6)+1;
	   end;

   end;
  end;

 procedure UrciInt;
  begin
    case R of
    Clovek:case P of
	   Kouzelnik:VL[Int].OrigVal:=13+Random(6)+1;
	   Lucistnik:VL[Int].OrigVal:=10+Random(6)+1;
	   Valecnik:VL[Int].OrigVal:=9+Random(6)+1;
	   end;
    Elf:case P of
	   Kouzelnik:VL[Int].OrigVal:=15+Random(6)+1;
	   Lucistnik:VL[Int].OrigVal:=12+Random(6)+1;
	   Valecnik:VL[Int].OrigVal:=11+Random(6)+1;
	   end;
    Thran:case P of
	   Kouzelnik:VL[Int].OrigVal:=14+Random(6)+1;
	   Lucistnik:VL[Int].OrigVal:=11+Random(6)+1;
	   Valecnik:VL[Int].OrigVal:=10+Random(6)+1;
	   end;
   end;
  end;

 procedure UrciVle;
  begin
    case R of
    Clovek,Thran:case P of
	   Valecnik,Lucistnik:VL[vle].OrigVal:=7+Random(6)+1;
	   Kouzelnik:VL[vle].OrigVal:=12+Random(6)+1;
	   end;
    Elf:case P of
	   Valecnik,Lucistnik:VL[vle].OrigVal:=8+Random(6)+1;
	   Kouzelnik:VL[vle].OrigVal:=13+Random(6)+1;
	   end;

   end;
  end;

  procedure UrciChr;
  begin
    case R of
    Clovek:VL[chr].OrigVal:=0+Random(6)+Random(6)+Random(6)+2;

    Elf,Thran:VL[chr].OrigVal:=6+Random(6)+1+Random(6)+1;

   end;
  end;

 procedure UrciPoh;
  begin
    case R of
    Clovek:VL[poh].OrigVal:=11+VL[bobr].origval+2*vl[bsil].origval;

    Elf:VL[poh].OrigVal:=12+VL[bobr].origval+2*vl[bsil].origval;

    Thran:VL[poh].OrigVal:=14+VL[bobr].origval+2*vl[bsil].origval;

   end;
  end;

 function Bon(A:it):it;
  begin
   case A of
   0,1:Bon:=-5;
   2,3:Bon:=-4;
   4,5:Bon:=-3;
   6,7:Bon:=-2;
   8,9:Bon:=-1;
   10,11,12:Bon:=0;
   13,14:Bon:=1;
   15,16:Bon:=2;
   17,18:Bon:=3;
   19,20:Bon:=4;
   21,22:Bon:=5;
   23,24:Bon:=6;
   25,26:Bon:=7;
   27,28:Bon:=8;
   29,30:Bon:=9;
   31,32:Bon:=10;

      end;
  end;

 procedure UrciBons;
  begin
   VL[BSil].OrigVal:=Bon(VL[Sil].OrigVal);
   VL[BObr].OrigVal:=Bon(VL[obr].OrigVal);
   VL[Bodl].OrigVal:=Bon(VL[odl].OrigVal);
   VL[Bint].OrigVal:=Bon(VL[int].OrigVal);
   VL[Bvle].OrigVal:=Bon(VL[vle].OrigVal);
   VL[Bchr].OrigVal:=Bon(VL[chr].OrigVal);

  end;

 procedure UrciMana;
  begin
   if P<>Kouzelnik then VL[Mana].Origval:=0
    else
     begin
      case VL[int].origval of
      8,9:vl[mana].origval:=14;
      10,11:vl[mana].origval:=17;
      12,13:vl[mana].origval:=19;
      14,15:vl[mana].origval:=21;
      16,17:vl[mana].origval:=22;
      18,19:vl[mana].origval:=24;
      20,21:vl[mana].origval:=27;
      22,23:vl[mana].origval:=30;
      end;
     end;
  end;

 procedure UrciZdravi;
  begin
   case P of
    Kouzelnik:vl[zdravi].origval:=6+random(6)+random(6)+random(6)+3+3;
    Lucistnik:vl[zdravi].origval:=6+random(6)+random(6)+random(6)+3+5;
    Valecnik:vl[zdravi].origval:=10+random(10)+random(10)+random(10)+3+3;

   end;
  end;


 begin
 Randomize;
 UrciSil;
 UrciObr;
 UrciOdl;
 UrciInt;
 UrciVle;
 UrciChr;
 UrciBons;
 UrciPoh;
 VL[BPoh].OrigVal:=Bon(VL[Poh].OrigVal);
 UrciMana;
 UrciZdravi;

 VVL:=VL;
 end;






end.