unit HM;
interface
uses Types,Out,Crt;


const

    SizeX=70;SizeY=70;

type

    TOBj=object
	  Name:string[20];

	 end;

    TLayer=array[1..SizeX,1..SizeY]of byte;

    TObjtype=(no,snpc,event,telep);

    TObjRec=record
             Pos:TPos;
             case typ:TObjtype of
             snpc:();
             event:();
             teleport:(Kam:TPos);
            end;

    TSpec=array[1..MaxSpec]of TObjRec;

    TMap=object
	    Base:TLayer;
	    LObj:TLayer;
            DefCol:it;
            Special:TSpec;
            ID:word;
            Name:string[30];
	    constructor Init;
	    procedure LoadMap(IDno:byte);
	    destructor Done;

	   end;




    TNPC=object(TObj)


	 end;

    TCreature=object(TObj)

	       Vl:TVlastnosti;
	       Pos:TPos;

	       Utok,
	       Obrana:TAttrib;
	       Gold:longint;

               procedure Move(M:TMap;ch:char);

	      end;


    THero=object(TCreature)

	   Povolani:TPovolani;
	   Rasa:TRasa;
	   Zt:TAttrib;
	   Uroven:TAttrib;

	  end;







     TPanel=object
	    Left,
	    Top,
	    Right,
	    Bottom:it;
	    FCol,BCol:it;
	    Style:it;
	    Name:string[30];

	    procedure Initialize;
	   end;

    TMapPanel=object(TPanel)


	    constructor Init;
	    procedure Update(M:TMap;P:TPos);
	    destructor Done;

	    end;

    THInfoPanel=object(TPanel)


	      constructor Init;
	      procedure Update(H:Thero);
	      destructor Done;


	      end;



    TArrowPanel=object(TPanel)

		constructor Init;
		procedure Update(H:THero;M:TMap);
		procedure Arr(key:char);
		destructor Done;
		end;


    TSList=array[1..MaxText]of string[45];

    TTextPanel=object(TPanel)
		IText:TSList;
		Rows,
                Last,lasto,
                Po,poo,
                MaxRow,
                Up:it;
                Wr:boolean;
		constructor Init;
		procedure LoadText(M:TMap;P:TPos);
		procedure Update;
		destructor Done;


	       end;

implementation



constructor TMapPanel.Init;
 begin
  Name:=' MAPA ';
  Left:=52;Top:=1;Right:=80;Bottom:=13;
  FCol:=15;BCol:=0;
  Style:=1;
  Initialize;

 end;



procedure TMapPanel.Update(M:TMap;P:TPos);
 var x,y:it;
     ch:char;
 begin
  {Initialize;}

  for x:=P.x-13 to P.x+13 do
    for y:=P.y-5 to P.y+5 do
     begin
      if (x<1)or(y<1)or(x>SizeX)or(y>SizeY)then  WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,0,0,#219)
         else
       begin
      case M.Base[x,y] of
      Zed:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,8,0,IWall);
      Poust:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,14,M.DefCol,ITerrain);
      Palma:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,10,M.DefCol,IPalma);
      Kaktus:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,2,M.DefCol,IKaktus);
      MapExit:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,RED,M.DefCol,IExit);
      VPotok:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,11,M.DefCol,IVPotok);
      VJez:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,Cyan,M.DefCol,IVJez);
      VMore:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,1,M.DefCol,IVMore);
      Teleport:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,11,M.DefCol,ITeleport);
      Gate:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,8,M.DefCol,IGate);
      SJehl:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,2,M.DefCol,ISJehl);
      SList:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,10,M.DefCol,ISList);
      Trava:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,2,M.DefCol,ITerrain);
      Savana:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,6,M.DefCol,ITerrain);
      PKam:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,7,M.DefCol,IPodlaha);
      PDrev:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,6,M.DefCol,IPodlaha);
      Cesta:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,7,M.DefCol,ICesta);
      Pole:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,14,M.DefCol,IPole);
      Snih:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,15,M.DefCol,ITerrain);

      end;
      case M.LObj[x,y]of
       E1..E6:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,12,M.DefCol,ICreature);
       T1..T5:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,15,M.DefCol,ITruhla);
       NPC:WriteAt(Left+x-P.x+14,Top+1+y-P.y+5,11,M.DefCol,INPC);

      end;
       end;
     end;
  WriteAt(Left+14,Top+6,1,M.DefCol,IHero);

 end;

destructor TMapPanel.Done;
 begin


 end;

constructor THInfoPanel.Init;
 begin
  Name:='';
  Left:=1;Top:=19;Right:=51;Bottom:=24;
  FCol:=15;BCol:=1;
  Style:=0;

  {Initialize;}

 end;

procedure TPanel.Initialize;
 begin
   DrawWindow(Left,Top,Right,Bottom,BCol,FCOl,Style,#219,NAME);

 end;

procedure THInfoPanel.Update(H:THero);
 begin
  Initialize;
  WriteAt(Left+2,Top+1,LightRed,BCol,H.name);
  WriteAt(Left+2,Top+3,LightGreen,BCol,H.Rasa.Name);
  WriteAt(Left+2,Top+4,LightGreen,BCol,H.Povolani.Name);
  WriteAt(Left+28,Top+3,Yellow,BCol,H.VL[Mana].Name);
  WriteAt(Left+28,Top+1,13,BCol,H.Utok.Name);
  WriteAt(Left+28,Top+2,13,BCol,H.Obrana.Name);
  WriteAt(Left+28,Top+4,Yellow,BCol,H.VL[Zdravi].Name);

  WriteAt(Left+28+length(H.Obrana.Name)+3,Top+1,15,BCol,Inttostr(H.Utok.CurVal)+'/'+Inttostr(H.Utok.OrigVal));
  WriteAt(Left+28+length(H.Obrana.Name)+3,Top+2,15,BCol,Inttostr(H.Obrana.CurVal));
  WriteAt(Left+28+length(H.Obrana.Name)+3,Top+3,15,BCol,Inttostr(H.VL[Mana].CurVal)+'/'+Inttostr(H.VL[Mana].origVal));
  WriteAt(Left+28+length(H.Obrana.Name)+3,Top+4,15,BCol,Inttostr(H.VL[Zdravi].CurVal)+'/'+Inttostr(H.VL[Zdravi].origVal));



 end;

destructor THInfoPanel.Done;
 begin
 end;

constructor TArrowPanel.Init;
 begin
 Name:='';
 Left:=52;Top:=14;Right:=80;Bottom:=24;
 FCol:=15;BCol:=1;
 Style:=0;
 {Initialize;}
 end;

procedure TArrowPanel.Arr(key:char);
 var Q:boolean;
 begin
  Q:=false;
  repeat
  case key of
  #0:begin
      WriteAt(51+14,22,8,7,#30);
      WriteAt(51+13,23,8,7,#17#31#16);
      Q:=true;
    end;
  kup:WriteAt(51+14,22,12,7,#30);
  kdown:WriteAt(51+14,23,12,7,#31);
  kleft:WriteAt(51+13,23,12,7,#17);
  kright:WriteAt(51+15,23,12,7,#16);
  end;
  if key<>#0 then delay(50);
  Key:=#0;
  until Q;
 end;

procedure TArrowpanel.Update(H:THero;M:TMap);
 begin
  Initialize;

  WriteAt(Left+1,Top+1,14,BCol,'Nachz se v:');  WriteAt(Left+16,Top+1,15,BCol,M.name);
  WriteAt(Left+1,Top+2,14,BCol,'Penz m:');WriteAt(Left+18,Top+2,15,BCol,Inttostr(H.Gold));
  WriteAt(Left+1,Top+3,14,BCol,'Tvoje '+H.Uroven.Name+':');WriteAt(Left+18,Top+3,15,BCol,Inttostr(H.Uroven.CurVal));
  WriteAt(Left+1,Top+4,14,BCol,'Tvoje '+H.Zt.Name+':');WriteAt(Left+18,Top+4,15,BCol,Inttostr(H.Zt.CurVal)
  +'/'+IntToStr(H.Zt.OrigVal));

  WriteAt(Left+1,Top+6,13,BCol,'Help(F1),Menu(F10)');


  Arr(#0);
 end;

destructor TArrowpanel.Done;
 begin
 end;


constructor TTextPanel.Init;
 begin
  Name:=' Informace o okol ';
  Left:=1;Top:=1;Right:=51;Bottom:=18;
  FCol:=15;BCol:=0;
  Style:=1;
  MaxRow:=Bottom-Top-2;
  Up:=1;
  Last:=-1000;Lasto:=-1000;
  Po:=-2;Poo:=-2;
  Wr:=true;
  Initialize;
 end;

procedure TTextPanel.Loadtext(M:TMap;P:TPos);
 var i,index:it;
     f:text;
     s,sec:string[45];
const al='@';
      alobj='O';
 begin
  po:=M.Base[p.x,p.y];
  poo:=M.LObj[p.x,p.y];
  if (last<>po)or(lasto<>poo) then
  begin
  Assign(f,'data\tpanel.dat');
  Reset(f);
  readln(f,s);
  for i:=1 to MaxText do
   IText[i]:='';

  i:=1;
  sec:=al+inttostr(po);
  while not eof(f) do
   begin
    readln(f,s);
    if s=sec then break;
   end;


  while (s<>'*')do
   begin
    readln(f,s);
    IText[i]:=s;
    inc(i);
   end;
  Rows:=i;
  Last:=po;
  Wr:=true;

  if poo<>0 then
   begin
    i:=Rows;
  case poo of
  E1..E6:index:=1;
  T1..T5:index:=2;
  NPC:index:=3;
  end;
  sec:=al+alobj+inttostr(index);
  while not eof(f) do
   begin
    readln(f,s);
    if s=sec then break;
   end;


  while (s<>'*')do
   begin
    readln(f,s);
    IText[i]:=s;
    inc(i);
   end;
   end;
  Rows:=i-1;
  Lasto:=poo;




  Close(f);
  end
   else Wr:=false;

 end;

procedure TTextpanel.Update;
 var i:it;
 begin
  {Initialize;  }
  if Wr then
  begin
  fillscr(left+1,top+1,right-1,bottom-1,0,0,#219);
  for i:=1 to Rows do
  writeat(2,2+i,2,0,itext[i]);
  end;

 end;

destructor TTextPanel.Done;
 begin
 end;


{**************************MAP*********************************}
constructor TMap.Init;
var i:it;

 begin
  for i:=1 to MaxSpec do
    Special[i].typ:=no;

 end;

procedure TMap.LoadMap(IDno:byte);
 const Ext='.map';
 var f,fs:Text;
     s:string[71];
     x,y,def:it;
     ch:char;
 begin
  Assign(f,'Data\Maps\'+IntToStr(IDno)+Ext);
  Assign(fs,'Data\Maps\'+Inttostr(IDno)+'.spe');
  Reset(fs);
  Reset(f);
  readln(f,s);
  readln(f,Self.Name);
  readln(f,def);
  readln(f,Self.DefCol);
  readln(f,Self.ID);
  readln(f,s);
  for y:=1 to SizeY do
    begin
     readln(f,s);
     for x:=1 to SizeX do
     begin
     Base[x,y]:=def;
     LObj[x,y]:=0;
     if x<=length(s) then
     case s[x] of
      'z','Z':Base[x,y]:=zed;
      'p','P':Base[x,y]:=palma;
      #10,#0,#13,#32,#9:Base[x,y]:=def;
      'j','J':Base[x,y]:=SJehl;
      'l','L':Base[x,y]:=SList;
      'k','K':Base[x,y]:=Kaktus;
      'v','V':Base[x,y]:=VPotok;
      'w','W':Base[x,y]:=VJez;
      'm','M':Base[x,y]:=VMore;
      '1':Base[x,y]:=Trava;
      '2':Base[x,y]:=Savana;
      '3':Base[x,y]:=Poust;
      '4':Base[x,y]:=PKam;
      '5':Base[x,y]:=PDrev;
      '6':Base[x,y]:=Snih;
      '7':Base[x,y]:=Pole;
      '8':Base[x,y]:=Cesta;
      '0','X','x':Base[x,y]:=MapExit;
      'g','G':Base[x,y]:=Gate;
      't','T':Base[x,y]:=teleport;
      'e','E':LObj[x,y]:=E2;
      '!':LObj[x,y]:=E1;
      '@':LObj[x,y]:=E2;
      '$':LObj[x,y]:=E4;
      '#':LObj[x,y]:=E3;
      '%':LObj[x,y]:=E5;
      '^':LObj[x,y]:=E6;
      '/':LObj[x,y]:=t1;
      '*':LObj[x,y]:=t2;
      '-':LObj[x,y]:=t3;
      '+':LObj[x,y]:=t4;
      '&':LObj[x,y]:=t5;
      'n':LObj[x,y]:=npc;


     end;

     end;
    end;
  Close(f);
  Close(fs);
 end;

destructor TMap.Done;
 begin
 end;

{************************ HERO & CREATURE **************************}
procedure TCreature.Move(M:TMap;ch:char);
 begin
  case ch of
   kup:if (pos.y>1) then if (M.Base[pos.x,pos.y-1]<>1) then dec(pos.y);
   kdown:if (pos.y<SizeY) then if(M.Base[pos.x,pos.y+1]<>1) then inc(pos.y);
   kleft:if (pos.x>1) then if(M.Base[pos.x-1,pos.y]<>1) then dec(pos.x);
   kright:if (pos.x<SizeX)then if(M.Base[pos.x+1,pos.y]<>1) then inc(pos.x);
  end;
 end;

end.