unit Classes;
interface

uses Out,Crt,Types,HM,Ing;

type

   
   TMenu=object
	  Rec:TMenuRec;
	  Selected:it;

	  constructor Init(R:TmenuRec);
	  procedure Initialize;
	  procedure DrawMenu;
	  procedure DrawButtons;
	  procedure Run;
	  procedure Run2(var C:char);
	  destructor Done;


	 end;
  
    
    TInfo=array[1..6,1..10]of string[40];


    TnewGame=object
	    NewMMenu,
	    RasMenu,
	    Povmenu,
	    AtrMenu:TMenu;
	    ToIng:TPack;
	    Rasa:TRasa;
	    Povo:TPovolani;
	    Name:string[20];
	    Vl,
	    SaveVl:TVlastnosti;
	    Zt,Ur:TAttrib;

	    Info:TInfo;

	    constructor Init;
	    procedure Run;
	    procedure DrawInfo;
	    procedure LoadInfo;
	    procedure DrawRP(Ras:boolean);
	    procedure Nameinput;
	    procedure DrawAttribs;
	    procedure DrawStory;
	    procedure InitPack;
	    destructor Done;

	  end;

	  
   PGame=^TGame;
   TGame=object
	   MainMenu:Tmenu;
	   NewGame:TNewGame;
	   Ingame:TIngame;
	   Loaded:boolean;

	   constructor Init;
	   procedure Initialize;
	   procedure DrawLogo(X,Y:it);
	   procedure Quit;
	   destructor Done;

	 end;
     
implementation



constructor Tgame.Init;
 begin
  DefineMenus;
  MainMenu.Selected:=1;
  Initialize;

 end;

destructor TGame.Done;
 begin

 end;

procedure TGame.Initialize;
var Exit:boolean ;
  begin
   Exit:=false;
   TextBackGround(0);
   ClrScr;
   SetCursor(nocur);
   FillScr(1,1,80,25,DarkGray,Black,#177);
   DrawLogo(1,25);
   NewGame.Init;
   Mainmenu.Init(MenuRecs[m_main]);
   repeat
   Mainmenu.Run;
   
   case MainMenu.Selected of
   1:begin NewGame.Run;Ingame.Init(@NewGame.ToIng);end;
   2:begin Ingame.Init(nil);end;
   3:begin writeat(1,1,14,4,'Pyrn Infef');end;
   4:Exit:=true;
   end;

   until Exit;
   Quit;

end;
  
procedure TGame.Quit;
 begin
  TextColor(15);
  TextBackGround(0);
  ClrScr;
  DrawLogo(1,1);
  Writeat(1,2,15,0,'Bye!');
  GotoXY(1,24);
  SetCursor(shortcur);
  Done;
 end;

procedure TGame.DrawLogo(X,Y:it);
 begin
  Writeat(X,Y,Yellow,Blue,#200#32+'MAR'+#32#188);
  Writeat(X+7,Y,Yellow,Black,'  -Ve Slubch Kothoru v.01PAS -Aug2000');
 end;



constructor Tmenu.Init(R:TMenuRec);
 begin
  Rec:=R;
  Selected:=1;
  Initialize;

 end;


procedure TMenu.Initialize;
 begin
  DrawMenu;

 end;

procedure TMenu.DrawMenu;

begin

 DrawWindow(Rec.Left,Rec.Top,Rec.Right,Rec.Bottom,Rec.MenuCol,Rec.BorderCol,Rec.FrameStyle,#177,'');

 Writeat(Rec.Left+((Rec.Right-Rec.Left-length(Rec.Name))div 2),Rec.Top+3,Rec.BorderCol,Rec.MenuCol,Rec.Name);
 DrawButtons;

end;

procedure TMenu.DrawButtons;
var up,space,mid,left,len:it;
   i:it;
   bcol,fcol:it;
begin
 space:=rec.bottom-rec.top-2-4;
 mid:=space div rec.topics;
 up:=rec.top+4;

 len:=0;
 for i:=1 to rec.topics do
  if length(rec.topicnames[i])>len then len:=length(rec.topicnames[i]);

 left:=rec.left+((rec.right-rec.left-len)div 2);
 inc(len,2);

 for i:=1 to rec.topics do
  begin
   if i=selected then 
    begin
     bcol:=rec.cbbutcol;fcol:=rec.cfbutcol;
    end
   else 
    begin
     bcol:=rec.bbutcol;fcol:=rec.fbutcol;
    end;


   fillscr(left,up+mid*i,left+len,up+mid*i,bcol,0,#219);
   writeat(left+((len-length(rec.topicnames[i]))div 2),up+mid*i,fcol,bcol,Rec.TopicNames[i]);

  end;

end;

procedure TMenu.Run2(var C:char);
 var Ch:Char;
 begin
  
   Ch:=readkey;
   case Ch of
   #72:if Selected<>1 then dec(Selected) else Selected:=Rec.Topics;
   #80:if Selected<>Rec.Topics then inc(selected)else selected:=1;
   end;

   DrawButtons;
   C:=ch;


 end;

procedure TMenu.Run;
 var ch:char;
  Exit:boolean;
 begin
  Exit:=false;
  repeat
   Run2(ch);
   if (ch=#13)or(ch=#32) then Exit:=true;
  until Exit;

 end;

destructor TMenu.Done;
 begin

 end;

constructor TNewgame.Init;
 begin
  Name:='Neznm Hrdina      ';
  Rasa:=Rasy[clovek];
  Povo:=Povolani[valecnik];
  LoadInfo;
  Vl:=Vlastnosti;

 end;

procedure TNewGame.Run;
 var Exit,Ex:boolean;
     ch:char;


 begin
  Exit:=false;
  Ex:=false;
  TextBackGround(0);
  ClrScr;
  NewMmenu.Init(MenuRecs[m_new]);
  repeat 
   TextBackGround(0);
   ClrScr;
   DrawInfo;
   NewMMenu.DrawMenu;
   NewMMenu.Run;
   case NewMMenu.Selected of
   1:NameInput;
   2:begin 
	RasMenu.Init(MenuRecs[m_ras]);
	repeat
	DrawRP(true);
	RasMenu.Run2(ch);
	if (ch=#13)or(ch=#32) then Ex:=true;
	until Ex;
	if rasmenu.selected=1 then 
	Rasa:=Rasy[clovek] else if rasmenu.selected=2 then rasa:=rasy[elf] else rasa:=rasy[thran];
	Ex:=false;

     end;


   3:begin 
	PovMenu.Init(MenuRecs[m_pov]);
	repeat
	DrawRP(false);
	PovMenu.Run2(ch);
	if (ch=#13)or(ch=#32) then Ex:=true;

	until Ex;
	if povmenu.selected=1 then 
	povo:=povolani[kouzelnik] else if povmenu.selected=2 then povo:=povolani[lucistnik] else povo:=povolani[valecnik];
	
	Ex:=false;

     end;
   4:Exit:=true;
   end;
  until Exit;

 Exit:=false;
 AtrMenu.Init(MenuRecs[m_atr]);
 CalcAttribs(Rasa.typ,Povo.typ,Vl,Vl);
 DrawAttribs;
 repeat
  Atrmenu.Run;
  
  
  case AtrMenu.Selected of
  1:begin CalcAttribs(rasa.typ,povo.typ,Vl,Vl);DrawAttribs;end;
  2:SaveVl:=Vl;
  3:begin Vl:=SaveVl;DrawAttribs;end;
  4:Exit:=true;
  end;

 until Exit;
 UrciUrZt(Povo.typ,Zt,Ur);
 InitPack;
 DrawStory;

 readkey;


 end;







procedure TNewGame.DrawInfo;
 begin
 fillscr(27,1,53,5,WHITE,0,#32);
 writeat(28,2,15,0,'Jmno:    '+name);
 writeat(28,3,15,0,'Rasa:     '+rasa.name);
 writeat(28,4,15,0,'Povoln: '+povo.name);
  
 end;

procedure TNewGame.LoadInfo;
 var f:text;
     i:it;
     line:string[80];
     ch:char;
 begin
  Assign(f,'data\nginfo.dat');
  Reset(f);
  readln(f,line);
  readln(f,line);
  for i:=1 to 10 do
   begin read(f,ch);readln(f,Info[1,i]);end;
  readln(f,line);
  for i:=1 to 10 do
   begin read(f,ch);readln(f,Info[2,i]);end;
  readln(f,line);
  for i:=1 to 10 do
   begin read(f,ch);readln(f,Info[3,i]);end;
  readln(f,line);
  for i:=1 to 10 do
   begin read(f,ch);readln(f,Info[4,i]);end;
  readln(f,line);
  for i:=1 to 10 do
   begin read(f,ch);readln(f,Info[5,i]);end;
  readln(f,line);
  for i:=1 to 10 do
   begin read(f,ch);readln(f,Info[6,i]);end;


  Close(f);
 end;

procedure Tnewgame.DrawRp(Ras:boolean);
 var i,x:it;
 begin
  if Ras then i:=rasmenu.Selected+3
   else i:=povmenu.selected;

  fillscr(27,8,53,20,0,0,#219);
  for x:=1 to 10 do
   writeat(27,8+x,15,0,Info[i,x]);

 end;

procedure Tnewgame.Nameinput;
 begin
  Writeat(37,12,15,0,'Napi svoje jmno:');
  Writeat(37,16,15,0,'esk klvesnice-ScrollLock');


  Name:=TextInput(37,14,20,14,4,Name);

 end;

procedure TNewGame.DrawAttribs;
 begin  
  FillScr(27,9,80,24,0,0,#219);
  WriteAt(30,10,11,0,Vl[Sil].Name+': ');Writeat(55,10,10,0,inttostr(Vl[sil].origval));
  WriteAt(30,11,11,0,Vl[obr].Name+': ');Writeat(55,11,10,0,inttostr(Vl[obr].origval));
  WriteAt(30,12,11,0,Vl[odl].Name+': ');Writeat(55,12,10,0,inttostr(Vl[odl].origval));
  WriteAt(30,13,11,0,Vl[int].Name+': ');Writeat(55,13,10,0,inttostr(Vl[int].origval));
  WriteAt(30,14,11,0,Vl[vle].Name+': ');Writeat(55,14,10,0,inttostr(Vl[vle].origval));
  WriteAt(30,15,11,0,Vl[chr].Name+': ');Writeat(55,15,10,0,inttostr(Vl[chr].origval));
  
  WriteAt(30,17,3,0,Vl[poh].Name+': ');Writeat(55,17,2,0,inttostr(Vl[poh].origval));
  WriteAt(30,18,3,0,Vl[mana].Name+': ');Writeat(55,18,2,0,inttostr(Vl[mana].origval));
  WriteAt(30,19,3,0,Vl[zdravi].Name+': ');Writeat(55,19,2,0,inttostr(Vl[zdravi].origval));
  
  


 end;

procedure TNewGame.DrawStory;
 var f:text;
     line:string[81];
     i:it;
 begin
 
  TextBackground(Black);
  ClrScr;
  DrawWindow(1,1,80,24,0,15,1,#219,'Jak to vechno zaalo');

  Assign(f,'data\nginfo.dat');
  Reset(f);
  while not eof(f) do
   begin
    readln(f,line);
    if line='@stry' then break;
   end;

  i:=1;
  while (i<22)do
   begin
    if eof(f)then break;
    readln(f,line);
    Writeat(2,2+i,11,0,line);
    inc(i);
   end;

 end;

procedure TNewgame.Initpack;
 var i:TAttribs;
 begin
  with ToIng do
   begin
    ToIng.Name:=Self.Name;
    R:=Rasa;
    P:=Povo;
    Z:=Zt;
    U:=Ur;

    for i:=Sil to Zdravi do
      VL[i].CurVal:=VL[i].OrigVal;
    V:=VL;
   
   end;
 end;

destructor TnewGame.Done;
 begin

 end;

end.










