unit Ing;
interface
uses Out,Crt,Types,HM;

type

    PPack=^TPack;
    TPack=record
	   Name:string[20];
	   P:TPovolani;
	   R:TRasa;
	   V:TVlastnosti;
	   Z:TAttrib;
	   U:TAttrib;
	  end;


    TIngame=object
	    Starting:TPack;
	    Hero:THero;
	    Map:TMap;

	    PMap:TMapPanel;
	    PHero:THInfoPanel;
	    PArrow:TArrowPanel;
	    PText:TTextPanel;


            constructor Init(Pack:PPack);
	    procedure LoadGame;
            procedure InitNewgame;
	    procedure Initialize;
	    procedure Run;
	    destructor Done;

	   end;




implementation



constructor TIngame.Init(Pack:PPack);
 begin
  Map.Init;
  if Pack<>nil then
  begin
  Starting:=Pack^;
  TextBackGround(0);
  ClrScr;
  
  InitNewgame;
  Map.Loadmap(1);


  end
  else LoadGame;



  Initialize;
  Run;
 end;

procedure TIngame.Initialize;
 begin
 PMap.Init;
 PHero.Init;
 PArrow.Init;
 PText.Init;
 ptext.loadtext(map,hero.pos);
 PMap.Update(Map,hero.pos);
 PHero.Update(Hero);
 PArrow.Update(Hero,Map);
 PText.Update;
 end;

procedure TIngame.InitNewGame;
 begin
  Hero.Name:=Starting.Name;
  Hero.VL:=Starting.V;
  Hero.Rasa:=Starting.R;
  Hero.Povolani:=Starting.P;
  Hero.Zt:=Starting.Z;
  Hero.Uroven:=Starting.U;
  Hero.Gold:=46;
  Hero.Utok:=cUtok;
  Hero.Obrana:=cObrana;
  Hero.Pos.X:=20;
  Hero.Pos.Y:=12;
 end;

procedure TIngame.LoadGame;
 begin

 end;

procedure TIngame.Run;
 var Ch:char;
     Exit:boolean;
 begin
  Exit:=false;
  Map.Loadmap(1);
  repeat
   ch:=readkey;
   case ch of
   kESC:Exit:=true;
   kUp,kleft,kdown,kright:begin Hero.Move(Map,ch);PArrow.Arr(ch);
       PText.LoadText(Map,hero.Pos);PText.Update;
       end;

   end;
   PMap.Update(Map,hero.Pos);
  until Exit;

 end;


destructor TIngame.Done;
 begin

 end;




end.